%product of all ellements of x
%dual2 case

function local = prod_elements(x)
    xD0 = x.f0;
    xD1 = x.f1;
    xD2 = x.f2;
    
    x0 = xD0(:);
    k0 = find (mynot(x0));
    lgz = length (k0);
    if (lgz >= 3)
        local = dual2(0, 0, 0);
    elseif (lgz == 2)
        x1 = xD1(:);
        NOx0 = mynot(x0);
        x0n = x0 + NOx0;
        x1n = x1.*NOx0 + mynot(NOx0);              
        f2 = 2*prod(x0n,1).*prod(x1n,1);
        local = dual2(0, 0, f2);
    elseif (lgz == 1)
        x1 = xD1(:);
        x2 = xD2(:);    
        NOx0 = mynot(x0);
        SIx0 = mynot(NOx0);
        newx0 = x0 + NOx0;    
        f0p = prod(newx0,1);
        f1 = f0p.*x1(k0);    
        px1k0 = (x1.*SIx0 + NOx0).*(kron(x1(k0),ones(size(x1))).*SIx0 + NOx0);
        f2a = 2*sum(f0p .* (px1k0./newx0).*SIx0,1);   
        f2b = prod(newx0,1) .* x2(k0);    
        f2 = f2a + f2b;
        local = dual2(0, f1, f2);
    else
        x1 = xD1(:);
        x2 = xD2(:);
        f0 = prod (x0,1);
        auxsum = sum(x1./x0);
        f1 = f0.*auxsum;
        f2 = f0.*sum(x2./x0 - (x1./x0).^2, 1) + f0.*auxsum.^2;
        local = dual2(f0, f1, f2);
    end
end
%

function local = mynot(A)    
    Ai=imag(A);
    Ar=real(A);
    local = ~Ai .* ~Ar;
end