%fr = d1mlf(f,v,q) computes the first order directional derivative
%of function f along vector v at the point q.
%f is a dual function D^m --> D^n (D^pm --> D^pn)
%v and q are a real (or complex) arrays of the same dimensions
%v = [v1, ... ,vm], alternatively
%v = [v11, ... ,v1m; v21, ... ,v2m; ... ;vp1, ... ,vpm]
%For convenience, v and q are assumed row vectors of dimension m, or
%as matrices of dimensions [p,m]. Notice that in the paper they are 
%assumed as kets (column vectors) of dimension m.
function fr = d1mlf(f,v,q)
    eps1 =  dual1(0,1);
    fqd = f(q + eps1.*v);
    fr = fqd.f1;
end
